let logger = require('./log');
let mqtt = require('./mqttHandler');

class HomematicFourButtonSingleItem {
    constructor(name, actionTopic) {
        this.name = name;
        this.actionTopic = actionTopic;
    }

    processMessage(topic, payload) {
        switch(topic) {
            case 'PRESS_SHORT':
                mqtt.send(this.actionTopic, 'SHORT', true);
                break;
            case 'PRESS_LONG':
            case 'PRESS_CONT':
                mqtt.send(this.actionTopic, 'LONG_HOLD', true);
                break;
            case 'PRESS_LONG_RELEASE':
                mqtt.send(this.actionTopic, 'LONG_END', true);
                break;
            default:
                logger.warn(`HM4BSI: no handling available for ${topic}`);
                break;
        }
    }
}

module.exports = HomematicFourButtonSingleItem;


