let logger = require('./log');
let mqtt = require('./mqttHandler');
let AHomematicItem = require('./AHomematicItem')

class HomematicFourButtonThing extends AHomematicItem {
    constructor(floor, room, item, hmId, itemObjs) {
        super(floor, room, item, hmId);
        this.itemObjs = itemObjs;
        if (this.itemObjs.length != 4) {
            throw new Error('itemObjs for HomematicFourButtonThing must have four elements');
        }
        this.subscribeTopics = [
            `${this.deviceTopicPre}/#` 
        ];
    }

    processMessage(topic, payload) {
        logger.info(`HM4B: ${topic}, ${payload}`);
        let buttonRelatedPart = topic.substring(this.deviceTopicPre.length+1);
        let buttonIdx = parseInt(buttonRelatedPart.substring(0, buttonRelatedPart.indexOf('/')));
        if (buttonIdx >= 1 && buttonIdx <= 4) {
            this.itemObjs[buttonIdx-1].processMessage(buttonRelatedPart.substring(buttonRelatedPart.indexOf('/')+1), payload);        
        } else {
            logger.warn(`HM4B: no handling available for ${topic}`);
        }
    }
}


module.exports = HomematicFourButtonThing;

